unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, ComCtrls, Grids, Buttons, Crt, (*Beachte KeyPreview im Formular*)
  Process;

type

  { TFormsimpleGUIfind }

  TFormsimpleGUIfind = class(TForm)
    BitBtnStart: TBitBtn;
    ButtonDialogPfadsuche: TButton;
    ButtonAbbruch: TButton;
    ButtonDialogGesamtesSystem: TButton;
    ButtonHomeDokumente: TButton;
    ButtonHome: TButton;
    CheckBoxMitRechten: TCheckBox;
    CheckBoxAdministrator: TCheckBox;
    CheckBoxSchreibung: TCheckBox;
    EditSuchDatei: TEdit;
    EditSuchpfad: TEdit;
    EditBefehl: TEdit;
    LabelSuchDatei: TLabel;
    LabelSuchpfad: TLabel;
    LabelBefehlFIND: TLabel;
    MemoAnleitung: TMemo;
    PanelComputer: TPanel;
    Process: TProcess;
    SelectDirectoryDialog: TSelectDirectoryDialog;
    StatusBar: TStatusBar;
    procedure BitBtnStartClick(Sender: TObject);
    procedure ButtonAbbruchClick(Sender: TObject);
    procedure ButtonDialogGesamtesSystemClick(Sender: TObject);
    procedure ButtonHomeClick(Sender: TObject);
    procedure ButtonHomeDokumenteClick(Sender: TObject);
    procedure ButtonDialogPfadsucheClick(Sender: TObject);
    procedure CheckBoxAdministratorChange(Sender: TObject);
    procedure CheckBoxMitRechtenChange(Sender: TObject);
    procedure CheckBoxSchreibungChange(Sender: TObject);
    procedure EditBefehlChange(Sender: TObject);
    procedure EditSuchpfadChange(Sender: TObject);
    procedure EditSuchDateiChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);

    procedure Befehl(Sender: TObject);

  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  FormsimpleGUIfind: TFormsimpleGUIfind;

  ParameterIName, ParameterLs, Admin:                     string;
  TextDatei:                                              TextFile;
  TextZeile:                                              string;

const
  Apostroph=#39;                                                                 // ASCII-Tabelle
  Ausfuehrungszeichen=#34;

implementation

{$R *.lfm}

{ TFormsimpleGUIfind }

(*--------------------------- StartBedingungen -------------------------------*)

procedure TFormsimpleGUIfind.FormCreate(Sender: TObject);

begin
  ParameterIname    := '-iname ';
  ParameterLs       := '-ls ';
  Admin             := '';
  EditSuchDatei.Text := '...';
  EditSuchpfad.Text := GetUserDir+'Dokumente/';
  EditBefehl.Text   := 'find '+EditSuchPfad.Text+' '+ParameterIname+
                       EditSuchDatei.Text+' '+ParameterLs;
  ButtonAbbruch.Enabled:=false;
  AssignFile(TextDatei,'/tmp/simpleGUIfind.sh');                                // /tmp
  Try                                                                           // Anlegen Skript für Rechte einstellen
    Rewrite(TextDatei);                                                         // hier günstig, da Rechte bei Rewrite erhalten bleiben!
    Except
      ShowMessage('Skript simpleGUIfind.sh kann nicht anlegen werden! Bitte Verzeichnisse und Rechte prüfen!');
      Halt;
  end;

  TextZeile:='#!/bin/bash';
  WriteLN(Textdatei,TextZeile);
  CloseFile(TextDatei);

  Process.CommandLine:='chmod 777 /tmp/simpleGUIfind.sh';                       // Recht einstellen /tmp
  Process.Active:=true;                                                         // eigentlicher Aufruf

  StatusBar.Panels[0].Text:='Programm simpleGUIfind gestartet. Die Voreinstellungen sind optimal!';
end;

(*--------------------------- Befehl -----------------------------------------*)

procedure TFormsimpleGUIfind.Befehl(Sender: TObject);

var i:                                      integer;
    joker:                                  boolean;

Begin
  joker:=False; Textzeile:=EditSuchDatei.Text;

  If Length(TextZeile)>0 then                                                   // Joker
    Begin
      for i:=1 to length(Textzeile) do
        if (Textzeile[i]='?') or (TextZeile[i]='*') then joker:=True;
      If (joker) and (Textzeile[1] <> '"') then Textzeile:='"'+TextZeile;
      If (joker) and (Textzeile[length(Textzeile)] <> '"') then TextZeile:=TextZeile+'"';
    end;

  EditBefehl.Text:=Admin+'find '+EditSuchPfad.Text+' '+ParameterIname+
                     TextZeile+' '+ParameterLs;
end;

(*--------------------------- Groß- Klein- Schreibung ------------------------*)

procedure TFormsimpleGUIfind.CheckBoxSchreibungChange(Sender: TObject);
begin
  If CheckBoxSchreibung.Checked=True then ParameterIname:='-iname '
                                     else ParameterIname:='-name ';
  Befehl(Sender);
  StatusBar.Panels[0].Text:='Einstellung für Unterschied Groß- und Kleinschreibung geändert.';
end;

procedure TFormsimpleGUIfind.EditBefehlChange(Sender: TObject);
begin

end;

(*--------------------------- Anzeige Rechte ---------------------------------*)

procedure TFormsimpleGUIfind.CheckBoxMitRechtenChange(Sender: TObject);
begin
  If CheckBoxMitRechten.Checked=True then ParameterLs:='-ls'
                                     else ParameterLs:='';
  Befehl(Sender);
  StatusBar.Panels[0].Text:='Einstellung für Ausgabe Rechte geändert.';
end;

(*--------------------------- Suche mit administrativen Rechten --------------*)

procedure TFormsimpleGUIfind.CheckBoxAdministratorChange(Sender: TObject);
begin
  If CheckBoxAdministrator.Checked=True then Admin:='sudo '
                                        else Admin:='';
    Befehl(Sender);
    StatusBar.Panels[0].Text:='Einstellung für Suche mit administrativen Rechten geändert.';
end;

(*--------------------------- SuchDatei --------------------------------------*)

procedure TFormsimpleGUIfind.EditSuchDateiChange(Sender: TObject);
begin
  Befehl(Sender);
  StatusBar.Panels[0].Text:='Suchdatei geändert.';
end;

(*--------------------------- Suchpfad ---------------------------------------*)

procedure TFormsimpleGUIfind.EditSuchpfadChange(Sender: TObject);
begin
  Befehl(Sender);
  StatusBar.Panels[0].Text:='Suchpfad geändert. Präziser Suchpfad verkürzt Suchzeit! Achte auf Groß- und Kleinschreibung!';
end;

(*--------------------------- Suchpfad /home/user/Dokumente ------------------*)

procedure TFormsimpleGUIfind.ButtonHomeDokumenteClick(Sender: TObject);
begin
  EditSuchpfad.Text:=GetUserDir+'Dokumente/';
  Befehl(Sender);
  StatusBar.Panels[0].Text:='Suchpfad /home/user/Dokumente eingestellt. Präziser Suchpfad verkürzt Suchzeit!';
end;

(*--------------------------- Suchpfad /home/user ----------------------------*)

procedure TFormsimpleGUIfind.ButtonHomeClick(Sender: TObject);
begin
  EditSuchpfad.Text:=GetUserDir;
  Befehl(Sender);
  StatusBar.Panels[0].Text:='Suchpfad /home/user eingestellt. Beachte längere Laufzeit!';
end;

(*--------------------------- Suche Gesamtes System --------------------------*)

procedure TFormsimpleGUIfind.ButtonDialogGesamtesSystemClick(Sender: TObject);
begin
  EditSuchpfad.Text:='/';
  Befehl(Sender);
  StatusBar.Panels[0].Text:='Suchpfad Gesamtes System eingestellt. Beachte längere Laufzeit! Beachte administrative Rechte!';
end;

(*--------------------------- Suche Pfad mit Dialog --------------------------*)

procedure TFormsimpleGUIfind.ButtonDialogPfadsucheClick(Sender: TObject);
begin
  if SelectDirectoryDialog.Execute then
    begin
      EditSuchpfad.Text:=SelectDirectoryDialog.FileName;
      Befehl(Sender);
      StatusBar.Panels[0].Text:='Suchpfad mit Dialog eingestellt. Beachte längere Laufzeit! Beachte administrative Rechte!';
    end;
end;

(*--------------------------- Suche ------------------------------------------*)

procedure TFormsimpleGUIfind.BitBtnStartClick(Sender: TObject);
begin
  If (EditSuchpfad.Text='') or (EditSuchDatei.Text='') or
     (EditBefehl.Text='') Then
  MessageDlg('Fehler: Eingaben unvollständig!',mtInformation,[mbOK],0)
                          Else
  Begin
    Try                                                                         // Anlegen Skript
      Rewrite(TextDatei);
      Except
        ShowMessage('Skript simpleGUIfind.sh kann nicht anlegen werden! Bitte Verzeichnisse und Rechte prüfen!');
        Halt;
    end;

    TextZeile:='#!/bin/bash';
    WriteLN(TextDatei,TextZeile);
    TextZeile:='# 22.05.2020 - Krankheit   ><>';
    WriteLN(Textdatei,TextZeile);
    TextZeile:='echo Start Skript simpleGUIfind.sh - Bitte haben Sie etwas Geduld!';
    WriteLN(Textdatei,TextZeile);
    TextZeile:='echo Befehl: '+EditBefehl.Text;
//    ShowMessage('Befehl: '+EditBefehl.Text);
    WriteLN(Textdatei,TextZeile);
    TextZeile:='echo';
    WriteLN(Textdatei,TextZeile);

    TextZeile:=EditBefehl.Text;
    WriteLN(Textdatei,TextZeile);

    TextZeile:='echo';
    WriteLN(Textdatei,TextZeile);
    TextZeile:='echo Ende Skript simpleGUIfind.sh - Danke für die Benutzung!';
    WriteLN(Textdatei,TextZeile);

    CloseFile(TextDatei);
    ButtonAbbruch.Enabled := true;
//    ShowMessage('Haltepunkt nach Rewrite einstellen');
    Process.CommandLine:='xterm -hold -sb -right -geometry 180x50 -e /tmp/./simpleGUIfind.sh';
    Process.Active:=true;                                                       // eigentlicher Aufruf

    StatusBar.Panels[0].Text:='Suche gestartet. Gedrückte Maustaste im Terminal-Fenster hält Suche an! Click auf x im Terminal-Fenster beendet Suche!   ><>';
  end;
end;

(*--------------------------- Abbruch ----------------------------------------*)

procedure TFormsimpleGUIfind.ButtonAbbruchClick(Sender: TObject);
begin
  Process.Active:=false;
  ButtonAbbruch.Enabled:=false;
  StatusBar.Panels[0].Text:='Ende / Abbruch angefordert.';
end;


end.

